package inheritance;

import java.util.*;
import javax.ejb.*;
import javax.persistence.*;

@Stateless
@Remote(MIDAO.class)
public class MIDAOBean implements MIDAO {
	@PersistenceContext
	private EntityManager manager;

	public void createPiano(String maker, String model, int price, int numOfKeys, int type) {
		Piano i = new Piano(maker, model, price, numOfKeys, type);
		manager.persist(i);
	}

	public void createOrgan(String maker, String model, int price, int numOfKeys, int type, int stop) {
		Organ i = new Organ(maker, model, price, numOfKeys, type, stop);
		manager.persist(i);
	}

        public List<MusicalInstrument> searchExpensiveMusicalInstrument(int price) {
		return manager.createQuery("SELECT i FROM MusicalInstrument i WHERE i.price >= :price").setParameter("price", price).setMaxResults(8).getResultList(); 
        }

        public List<MusicalInstrument> searchExpensivePiano(int price) {
		return manager.createQuery("SELECT i FROM Piano i WHERE i.price >= :price").setParameter("price", price).setMaxResults(8).getResultList(); 
        }

        public List<MusicalInstrument> searchExpensiveOrgan(int price) {
		return manager.createQuery("SELECT i FROM Organ i WHERE i.price >= :price").setParameter("price", price).setMaxResults(8).getResultList(); 
        }
}
