package pm;

import java.sql.Timestamp;
import java.util.*;
import javax.persistence.*;

@Entity
@Table(name = "POCKET_MONEY")
public class PocketMoney implements java.io.Serializable {
	protected int id;
	protected String owner;
	protected int remaining;
	private Collection<PocketMoneyLine> lines = new ArrayList<PocketMoneyLine>();

	public PocketMoney() {
	}

	public PocketMoney(String owner, int remaining) {
		this.owner = owner;
		this.remaining = remaining;
	}

	public String toString() {
		return this.getClass().getName() + ", Owner[" + owner + "], remaining[" + remaining + "]";
	}

	@Id(generate = GeneratorType.AUTO)
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getOwner() {
		return owner;
	}

	public void setOwner(String owner) {
		this.owner = owner;
	}

	public int getRemaining() {
		return remaining;
	}

	public void setRemaining(int remaining) {
		this.remaining = remaining;
	}

	@OneToMany(cascade=CascadeType.ALL, fetch=FetchType.EAGER, mappedBy="pm")
	//@OneToMany(cascade=CascadeType.ALL, fetch=FetchType.LAZY, mappedBy="pm")
	public Collection<PocketMoneyLine> getLines() {
		return lines;
	}

	public void setLines(Collection<PocketMoneyLine> lines) {
		this.lines = lines;
	}

	public void deposit(int amount, String reason, Category category) {
		setRemaining(getRemaining() + amount);
		PocketMoneyLine line = new PocketMoneyLine(new Timestamp(System.currentTimeMillis()), amount, reason, category, this);
		getLines().add(line);
	}

	public void payment(int amount, String reason, Category category) {
		this.deposit(- amount, reason, category);
	}
}
