package pm;

import java.util.*;
import javax.persistence.*;

@Entity
@Table(name = "POCKET_MONEY_LINE")
public class PocketMoneyLine implements java.io.Serializable
{
	protected int id;
	protected Date timestamp;
	protected int balance;
	protected String reason;
	protected Category category;
	protected PocketMoney pm;

	public PocketMoneyLine() {
	}

	public PocketMoneyLine(Date timestamp, int balance, String reason, Category category, PocketMoney pm) {
		this.timestamp = timestamp;
		this.balance = balance;
		this.reason = reason;
		this.category = category;
		this.pm = pm;
	}
		
	public String toString() {
		return this.getClass().getName() + ", Balance[" + balance + "], Reason[" + reason + "], Category[" + category + "]";
	}
		
	@Id(generate = GeneratorType.AUTO)
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Date getTimestamp() {
		return timestamp;
	}

	public void setTimestamp(Date timestamp) {
		this.timestamp =timestamp;
	}

	public int getBalance() {
		return balance;
	}

	public void setBalance(int balance) {
		this.balance = balance;
	}

	public String getReason() {
		return reason;
	}

	public void setReason(String reason) {
		this.reason = reason;
	}

	@ManyToOne
	@JoinColumn(name = "category")
	public Category getCategory() {
		return category;
	}

	public void setCategory(Category category) {
		this.category = category;
	}

	@ManyToOne
	@JoinColumn(name = "pm")
	public PocketMoney getPm() {
		return pm;
	}

	public void setPm(PocketMoney pm) {
		this.pm = pm;
	}
}
